﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.5
@EndOfDesignText@
Sub Class_Globals
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private Serial1 As Serial
	Private Astream As AsyncStreams
	Private Connected As Boolean
	Private ConnectedError As String
	
End Sub

Public Sub Initialize(vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
	Serial1.Initialize("Serial1")
	Connected = False
	ConnectedError = ""
End Sub

Public Sub ConnectedErrorMsg As String
	Return ConnectedError
End Sub


Public Sub IsConnected As Boolean
	Return Connected
End Sub

Public Sub IsBluetoothOn As Boolean
	Return Serial1.IsEnabled
End Sub

Public Sub Connect As ResumableSub
	Dim PairedDevices As Map
	PairedDevices = Serial1.GetPairedDevices
	Dim l As List
	l.Initialize
	For i = 0 To PairedDevices.Size - 1
		l.Add(PairedDevices.GetKeyAt(i))
	Next
	InputListAsync(l, "Selecciona un Datafono", -1, False)
	Wait For InputList_Result (Index As Int)
	If Index <> DialogResponse.CANCEL Then
		Log("Selecciona ingenico: " & l.Get(Index))
		Serial1.Connect(PairedDevices.Get(l.Get(Index)))
		Return True
	End If
	Return False
End Sub

Public Sub DisConnect
	Serial1.Disconnect
	Connected = False
End Sub

Private Sub Serial1_Connected (Success As Boolean)
	If Success Then
		Astream.Initialize(Serial1.InputStream, Serial1.OutputStream, "astream")
		Connected = True
		ConnectedError = ""
		Serial1.Listen
	Else
		Connected = False
		ConnectedError = LastException.Message
	End If
	If SubExists(CallBack, EventName & "_Connected") Then
		CallSub2(CallBack, EventName & "_Connected", Success)
	End If
End Sub

Private Sub AStream_NewData (Buffer() As Byte)
	If SubExists(CallBack, EventName & "_NewData") Then
		CallSub2(CallBack, EventName & "_NewData", Buffer)
	End If
	Log("Data " & Buffer(0))
End Sub

Private Sub AStream_Error
	Connected = False
	If SubExists(CallBack, EventName & "_Error") Then
		CallSub(CallBack, EventName & "_Error")
	End If
End Sub

Private Sub AStream_Terminated
	Connected = False
	If SubExists(CallBack, EventName & "_Terminado") Then
		CallSub(CallBack, EventName & "_Terminado")
	End If
End Sub

Public Sub WriteString(data As String)
	WriteString2(data, "PCLINPUTSIMUL")
End Sub

Public Sub WriteString2(data As String, encoding As String)
	Try
		If Connected Then
			Astream.Write(data.GetBytes(encoding))
		End If
	Catch
		Log("Datáfono error : " & LastException.Message)
		AStream_Error
	End Try
End Sub

Public Sub WriteBytes(data() As Byte)
	If Connected Then
'		Log("Enviado: " & data)
		Astream.Write(data)
	End If
End Sub